/* vxhost.c
**
** translate the connection IP number into a virtual hostname using
** the IP4TRANS entries in the user database
**
*/

#include <stdio.h>
#include <string.h>

#include "dbif.h"
#include "tools.h"
#include "hlsock.h"
#include "mrmacs.h"
#include "userdb.h"

#define _VXHOST_C
#include "vxhost.h"

char **gargv = NULL;
char *vxhost_name = NULL;
char *thishost = NULL;
static char *ipbuf = NULL;
static char *remote_addr;

void vxhost_setup (void)
{
    dbif_rec *rec;
    int rt;
    unlessnull (rec = dbif_get (userdb, "::VXMAIL::")) {
	thishost = gdupl (__FILE__, __LINE__, rec->passwd);
	dbif_free (rec);
    } else {
	thishost = gdupl (__FILE__, __LINE__, "localhost");
    }
    /* [xxx.xxx.xxx.xxx] */
    unlessnull (ipbuf = LLSockname (0)) {
	rec = dbif_get (userdb, ipbuf);
	ifnull (rec) { return; }
	rt = dbif_rectype(rec);
	if (rt != RT_IP4TRANS && rt != RT_IP6TRANS) {
	    dbif_free (rec);
	    return;
	}
	if (vxhost_name) { gfree (vxhost_name); }
	vxhost_name = gdupl (__FILE__, __LINE__, rec->folder);
	dbif_free (rec);
	return;
    }
}

const char *IPstr (void)
{
    if (noNULL(ipbuf) && *ipbuf) { return ipbuf; }
    vxhost_setup ();
    return noNULL(ipbuf) ? ipbuf : "<<UNKNOWN>>";
}

const char *RADDRstr (void)
{
    ifnull (remote_addr) {
	remote_addr = LLPeername (0);
    }
    return remote_addr;
}

const char *mailhost (void)
{
    return thishost;
}
